<?php

namespace App\Http\Controllers;

use App\Models\TypeUnite;
use App\Models\Unite;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use RealRashid\SweetAlert\Facades\Alert;

class UniteController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $typeUnite=TypeUnite::all();
        return view('Admin.pages.File_Unite.Unite',compact('typeUnite'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $donnees = DB::table('unites')
        ->join('type_unites', 'unites.typeUnite_id', '=', 'type_unites.id')
        ->select('unites.id', 'unites.code_Unite', 'type_unites.nomType')
        ->get();
        // Remplacez "VotreModele" par le nom de votre modèle de données

    return response()->json($donnees);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = array(
            'code_Unite' => 'required',
            'typeUnite_id' => 'required',
        );

        $error = Validator::make($request->all(), $rules);

        if ($error->fails()) {
            Alert::toast('Add success','success');

            return redirect()->back()->withErrors($error)->withInput();
        }

        try {
            $form_data = array(

                'code_Unite' => $request->code_Unite,
                'typeUnite_id' => $request->typeUnite_id,

            );
            Unite::create($form_data);
            Alert::toast('Add success','success');
            return redirect()->back()->withInput();
        } catch (\Illuminate\Database\QueryException $exception) {
        Alert::toast('Une erreur s\'est produite lors de l\'ajout','error' /*. $exception->getMessage()*/);
            return redirect()->back()->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request)
    {


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
      public function edit($id)
    {
        $Unites = Unite::find($id);
        return response()->json([
            'status' => 200,
            'Unites' => $Unites,
        ]);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        //la route update a été détacher de la route ressource  (faite un php artisan route:list)
        $Unite_id = $request->input('id');
        $Unite = Unite::find($Unite_id);
        try {
            $Unite->code_Unite = $request->input('code_Unite');
            $Unite->typeUnite_id = $request->input('typeUnite_id');
            $Unite->update();
            Alert::toast('Update success','success');
            return redirect()->route('Unite.index');
        } catch (\Illuminate\Database\QueryException $exception) {
            Alert::toast('Veuillez rempli tous champs','error');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\GestionUnite  $gestionUnite
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {

        $data_id = $request->input('deleteUnite');
        $data = Unite::find($data_id);

        try {
            $data->delete();
            Alert::toast('Delete success','success');
        } catch (\Illuminate\Database\QueryException $exception) {
            $errorInfo = $exception->errorInfo;

            if ($errorInfo[0] === '23000' && $errorInfo[1] === 1451) {
                $affectedTables = $this->getAffectedTables($errorInfo[2]);
                $errorMessage = "Impossible de supprimer l'événement. Il est référencé dans les tableaux suivants : " . implode(", ", $affectedTables);
                Alert::toast($errorMessage,'error');
            } else {
                Alert::toast($exception->getMessage(),'error');
            }
        }

        return  redirect()->back()->withInput();
    }

    private function getAffectedTables($errorMessage)
    {
        preg_match_all("/`(.+?)`/", $errorMessage, $matches);
        return $matches[1];
    }
}
